# HG changeset patch
# User Pantxo Diribarne <pantxo.diribarne@gmail.com>
# Date 1636580357 18000
#      Wed Nov 10 16:39:17 2021 -0500
# Node ID 40f7c84e3dee531c9a6fb78f333952fe2c04f105
# Parent  7835150ba1754b89df6a36480ec4c65b78500aa2
genpropdoc.m: Add categories for better readability

* genpropdoc.m (getdoc): Add new field "category" which defaults to
  "miscellaneous". Give most documented properties a category.
  (printdoc): use @chapheading to display categories.

diff -r 7835150ba175 -r 40f7c84e3dee doc/interpreter/genpropdoc.m
--- a/doc/interpreter/genpropdoc.m	Tue Nov 02 11:00:45 2021 -0400
+++ b/doc/interpreter/genpropdoc.m	Wed Nov 10 16:39:17 2021 -0500
@@ -99,6 +99,8 @@
   ## -"printdefault": a boolean (def. true) that specifies whether the
   ##   default value should be printed.  It is useful for properties
   ##   like root "screendepth" that default to screen dependent values.
+  ##
+  ## -"category": a string that is used to order properties.
 
   packopt = @(c) strjoin (c, " | ");
   markdef = @(s) ["@{" s "@}"];
@@ -138,7 +140,8 @@
   if (isfield (base, field))
     s = base.(field);
   else
-    s = struct ("valid", "", "default", "", "doc", "", "printdefault", true);
+    s = struct ("valid", "", "default", "", "doc", "", ...
+                "printdefault", true, "category", "Miscellaneous");
   endif
 
   ## Base properties: Write generic documentation because it will be included
@@ -148,6 +151,8 @@
   if (strcmp (objname, "base"))
     switch (field)
       case "beingdeleted"
+        s.category = "Creation/Deletion";
+
       case "busyaction"
         s.doc = "Define how Octave handles the execution of this object's \
 callback properties when it is unable to interrupt another object's \
@@ -157,23 +162,28 @@
 indicates whether the interrupting callback is queued (@qcode{\"queue\"} \
 (default)) or discarded (@qcode{\"cancel\"}).\n\
 @xref{Callbacks, , @w{Callbacks section}}.";
+        s.category = "Callback Execution";
 
       case "buttondownfcn"
         s.doc = "__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "children"
         s.doc = "Graphics handles of the __objname__'s children.";
         s.valid = "vector of graphics handles";
+        s.category = "Parent/Children";
 
       case "clipping"
         s.doc = "If __prop__ is @qcode{\"on\"}, the __objname__ is \
 clipped in its parent axes limits.";
+        s.category = "Display";
 
       case "contextmenu"
         s.doc = "Graphics handle of the uicontextmenu object that is \
 currently associated to this __objname__ object.";
         s.valid = valid_handle;
+        s.category = "Mouse Interaction";
 
       case "createfcn"
         s.doc = "Callback function executed immediately after __objname__ \
@@ -181,15 +191,18 @@
 e.g., @code{set (groot, \"default__objname__createfcn\", \
 'disp (\"__objname__ created!\")')}.\n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Creation/Deletion";
 
       case "deletefcn"
         s.doc = "Callback function executed immediately before __objname__ \
 is deleted.\n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Creation/Deletion";
 
       case "handlevisibility"
         s.doc = "If __prop__ is @qcode{\"off\"}, the __objname__'s \
 handle is not visible in its parent's \"children\" property.";
+        s.category = "Parent/Children";
 
       case "hittest"
         s.doc = "Specify whether __objname__ processes mouse events \
@@ -199,6 +212,7 @@
 @qcode{\"currentobject\"}.  This property is only relevant when the object \
 can accept mouse clicks which is determined by the @qcode{\"pickableparts\"} \
 property.  @xref{XREF__objname__pickableparts, , @w{pickableparts property}}.";
+        s.category = "Mouse Interaction";
 
       case "interruptible"
         s.doc = "Specify whether this object's callback functions may be \
@@ -206,10 +220,12 @@
 and callbacks that make use of @code{drawnow}, @code{figure}, @code{waitfor}, \
 @code{getframe} or @code{pause} functions are eventually interrupted.\n\
 @xref{Callbacks, , @w{Callbacks section}}.";
+        s.category = "Callback Execution";
 
       case "parent"
         s.doc = "Handle of the parent graphics object.";
         s.valid = valid_handle;
+        s.category = "Parent/Children";
 
       case "pickableparts"
         s.doc = "Specify whether __objname__ will accept mouse clicks.  \
@@ -221,26 +237,35 @@
 object is configured to accept mouse clicks the @qcode{\"hittest\"} property \
 will determine how they are processed.  \
 @xref{XREF__objname__hittest, , @w{hittest property}}.";
+      s.category = "Mouse Interaction";
 
       case "selected"
+      s.category = "Mouse Interaction";
+
       case "selectionhighlight"
+      s.category = "Mouse Interaction";
+
       case "tag"
         s.doc = "A user-defined string to label the graphics object.";
         s.valid = valid_string;
+        s.category = "Text Appearance";
 
       case "type"
         s.doc = "Class name of the graphics object.  __prop__ is \
 always @qcode{\"__objname__\"}";
         s.valid = valid_string;
         s.printdefault = false;
+        ##Uncategorized
 
       case "userdata"
         s.doc = "User-defined data to associate with the graphics object.";
         s.valid = "Any Octave data";
+        s.category = "Data";
 
       case "visible"
         s.doc = "If __prop__ is @qcode{\"off\"}, the __objname__ is \
 not rendered on screen.";
+        s.category = "Display";
     endswitch
 
   ## Root properties:
@@ -252,94 +277,118 @@
             "hittest", "interruptible", "selected", ...
             "selectionhighlight", "uicontextmenu", "visible"}
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "parent"
         s.doc = "Root object has no parent graphics object.  __prop__ \
 is always empty.";
+        s.category = "Parent/Children";
 
       case "hittest"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "pickableparts"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "callbackobject"
         s.doc = "Graphics handle of the current object whose callback is executing.";
         s.valid = valid_handle;
+        s.category = "Calback Execution";
 
       case "currentfigure"
         s.doc = "Graphics handle of the current figure.";
         s.valid = valid_handle;
+        ##Uncategorized
 
       case "diary"
         s.doc = "If __prop__ is @qcode{\"on\"}, the Octave command window \
 session is saved to file.  @xref{XREFrootdiaryfile, , @w{diaryfile property}}.";
+        s.category = "Command Logging";
 
       case "diaryfile"
         s.doc = "The name of the diary file.  \
 @xref{XREFdiary, , @w{diary function}}.";
         s.valid = valid_string;
+        s.category = "Command Logging";
 
       case "echo"
         s.doc = "Control whether Octave displays commands executed from \
 scripts.  @xref{XREFecho, , @w{echo function}}.";
+        s.category = "Command Window Display";
 
       case "errormessage"
         s.doc = "The last error message raised.  \
 @xref{XREFlasterr, , @w{lasterr function}}.";
         s.valid = valid_string;
+        ##Uncategorized
 
       case "fixedwidthfontname"
         s.valid = valid_string;
+        s.category = "Command Window Display";
 
       case "format"
         s.doc = "This property is a wrapper around the @code{format} function.\
   @xref{XREFformat, , @w{format function}}.";
+        s.category = "Command Window Display";
 
       case "formatspacing"
         s.doc = "This property is a wrapper around the @code{format} function.\
   @xref{XREFformat, , @w{format function}}.";
+        s.category = "Command Window Display";
 
       case "language"
         s.valid = valid_string;
+        ##Uncategorized
 
       case "monitorpositions"
         s.doc = doc_unused;
         s.printdefault = false;
+        s.category = "Screen Info.";
 
       case "pointerlocation"
         s.doc = doc_unused;
         s.valid = valid_2elvec;
+        s.category = "Pointer Info.";
 
       case "pointerwindow"
         s.doc = doc_unused;
         s.valid = valid_handle;
+        s.category = "Pointer Info.";
 
       case "recursionlimit"
         s.doc = "The maximum number of times a function can be called \
 recursively.  \
 @xref{XREFmax_recursion_depth, , @w{max_recursion_depth function}}.";
         s.valid = "double";
+        ##Uncategorized
 
       case "screendepth"
         s.valid = "double";
         s.printdefault = false;
+        s.category = "Screen Info.";
 
       case "screenpixelsperinch"
         s.valid = "double";
         s.printdefault = false;
+        s.category = "Screen Info.";
 
       case "screensize"
         s.valid = valid_4elvec;
         s.printdefault = false;
+        s.category = "Screen Info.";
 
       case "showhiddenhandles"
         s.doc = "If __prop__ is @qcode{\"on\"}, all graphics objects handles \
 are visible in their parents' children list, regardless of the value of their \
 @code{handlevisibility} property.";
+        s.category = "Parent/Children";
 
       case "units"
+        s.doc = "Units in which screen information is returned."
+        s.category = "Screen Info.";
     endswitch
 
   ## Figure properties
@@ -348,37 +397,47 @@
       ## Overridden shared properties
       case "clipping"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "pickableparts"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "alphamap"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Appearance";
 
       case "closerequestfcn"
         s.doc = "Function that is executed when a figure is deleted.  \
 @xref{XREFclosereq, , closereq function}.\n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Creation/Deletion";
 
       case "color"
         s.doc = "Color of the figure background.  \
 @xref{Colors, , colorspec}.";
         s.valid = valid_color;
+        s.category = "Appearance";
 
       case "colormap"
         s.doc = "A matrix containing the RGB color map for the current axes.";
         s.valid = "N-by-3 matrix";
+        s.category = "Appearance";
 
       case "currentaxes"
-        s.doc = "Handle to the graphics object of the current axes.";
+        s.doc = "Handle to the graphics object of the current axes.  \
+@xref{XREFgca, , gca function}."
         s.valid = valid_handle;
+        ##Uncategorized
 
       case "currentcharacter"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "currentobject"
         s.valid = valid_handle;
+        ##Uncategorized
 
       case "currentpoint"
         s.doc = "A 1-by-2 matrix which holds the coordinates of the point \
@@ -396,28 +455,35 @@
 only if the figure's callback @code{windowbuttonmotionfcn} is defined\n\
 @end table";
         s.valid = valid_2elvec;
+        s.category = "Mouse Interaction";
 
       case "dockcontrols"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "filename"
         s.doc = "The filename used when saving the plot figure.";
         s.valid = valid_string;
+        s.category = "Printing/Saving";
 
       case "graphicssmoothing"
         s.doc = "Use smoothing techniques to reduce the appearance of jagged lines.";
+        s.category = "Appearance";
 
       case "integerhandle"
         s.doc = "Assign the next lowest unused integer as the Figure number.";
+        ##Uncategorized
 
       case "inverthardcopy"
         s.doc = "Replace the figure and axes background color with white when printing.";
+        s.category = "Printing/Saving";
 
       case "keypressfcn"
         s.doc = "Callback function executed when a keystroke event \
 happens while the figure has focus. The actual key that was pressed \
 can be retrieved using the second argument 'evt' of the function.  __fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Keyboard Interaction";
 
       case "keyreleasefcn"
         s.doc = "With @code{keypressfcn}, the keyboard callback functions.  \
@@ -436,29 +502,35 @@
 @end table\
 \n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Keyboard Interaction";
 
       case "menubar"
         s.doc = "Control the display of the figure menu bar at the top \
 of the figure.";
+        s.category = "Mouse Interaction";
 
       case "name"
         s.doc = "Name to be displayed in the figure title bar.  The name is \
 displayed to the right of any title determined by the @code{numbertitle} \
 property.";
         s.valid = valid_string;
+        s.category = "Appearance";
 
       ## FIXME: Uncomment when support added in graphics.in.h
       #case "number"
       #  s.doc = "Number of current figure (RO).";
+      #  ##Uncategorized
 
       case "nextplot"
         s.doc = "__prop__ is used by high level plotting functions to \
 decide what to do with axes already present in the figure.  \
 @xref{XREFnewplot, , @w{newplot function}}.";
+        ##Uncategorized
 
       case "numbertitle"
         s.doc = "Display \"Figure\" followed by the numerical figure handle \
 value in the figure title bar.";
+        s.category = "Appearance";
 
       case "outerposition"
         s.doc = "Specify the position and size of the figure including \
@@ -467,6 +539,7 @@
 and width and height of the figure.  \
 @xref{XREFfigureunits, , @w{units property}}.";
         s.valid = valid_4elvec;
+        s.category = "Position";
 
       case "paperorientation"
         s.doc = "The value for the @code{papersize}, and @code{paperposition} \
@@ -474,6 +547,7 @@
 @code{papersize} and @code{paperposition} reverse order \
 when __prop__ is switched between @code{\"portrait\"} and \
 @code{\"landscape\"}.";
+        s.category = "Printing/Saving";
 
       case "paperposition"
         s.doc = "Vector @code{[left bottom width height]} defining the \
@@ -485,6 +559,7 @@
 ignored.  \
 __modemsg__.";
         s.valid = valid_4elvec;
+        s.category = "Printing/Saving";
 
       case "paperpositionmode"
         s.doc = "If __prop__ is set to @qcode{\"auto\"}, the \
@@ -492,6 +567,7 @@
 figure will have the same size as the on-screen figure and will be centered \
 on the output page.  Setting the __prop__ to @code{\"auto\"} does not modify \
 the value of the @code{paperposition} property.";
+        s.category = "Printing/Saving";
 
       case "papersize"
         s.doc = "Vector @code{[width height]} defining the size of the \
@@ -502,16 +578,19 @@
 supported @code{papertype} and consistent with the @code{paperorientation}, \
 the @code{papertype} value is modified to the associated value.";
         s.valid = valid_2elvec;
+        s.category = "Printing/Saving";
 
       case "papertype"
         s.doc = "Name of the paper used for printed output.  \
 Setting __prop__ also changes @code{papersize}, while maintaining consistency \
 with the @code{paperorientation} property.";
+        s.category = "Printing/Saving";
 
       case "paperunits"
         s.doc = "The unit used to compute the @code{paperposition} property.  \
 The conversion from physical units (e.g., @code{\"inches\"}) is dependent on \
 the @code{screenpixelsperinch} property of the root object.";
+        s.category = "Printing/Saving";
 
       case "pointer"
         s.doc = "Name of the mouse pointer shape associated with the canvas \
@@ -520,6 +599,7 @@
 __prop__ has no effect when the figure is in zoom, pan, or rotate mode. \
 In this case, Octave automatically uses a pointer shape appropriate \
 to the mode.";
+        s.category = "Mouse Interaction";
 
       case "pointershapecdata"
         s.doc ="m-by-m matrix defining a custom pointer.  Each \
@@ -527,11 +607,13 @@
 top-left pixel.  A value of 1 is colored black, a value of 2 is colored white, \
 and all other values are rendered as transparent.";
         s.valid = "16-by-16 or 32-by-32 Matrix";
+        s.category = "Mouse Interaction";
 
       case "pointershapehotspot"
         s.doc ="For custom pointers only __prop__ defines the row and column \
 of the pixel in @code{pointershapecdata} that is used as the pointer location.";
         s.valid = valid_2elvec;
+        s.category = "Mouse Interaction";
 
       case "position"
         s.doc = "Specify the position and size of the figure canvas.  \
@@ -539,25 +621,30 @@
 and width and height of the figure.  \
 @xref{XREFfigureunits, , @w{units property}}.";
         s.valid = valid_4elvec;
+        s.category = "Position";
 
       case "renderer"
         s.doc = "Rendering engine used for printing when @code{renderermode} \
 is \"manual\".  __modemsg__.";
+        s.category = "Printing/Saving";
 
       case "renderermode"
         s.doc = "Control whether the rendering engine used for printing is \
 chosen automatically or specified by the @code{renderer} property.  \
 @xref{XREFprint, , @w{print function}}.";
+        s.category = "Printing/Saving";
 
       case "resize"
         s.doc = "Control whether the figure can be resized by dragging the \
 window borders and corners using a mouse.  When __prop__ is @qcode{\"off\"} \
 mouse interactions are disabled but the figure can still be resized by \
 changing its @qcode{\"position\"} property.";
+        s.category = "Mouse Interaction";
 
       case "resizefcn"
         s.doc = "__prop__ is deprecated.  Use @code{sizechangedfcn} instead.";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "selectiontype"
         s.doc = "Selection type of the latest mouse click.\n\n\
@@ -573,29 +660,35 @@
 @item open:\n\
 Double Left-click.\n\
 @end table";
+        s.category = "Mouse Interaction";
 
       case "sizechangedfcn"
         s.doc = "Callback triggered when the figure window size is changed.\
 \n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "toolbar"
         s.doc = "Control the display of the toolbar (along the bottom of the \
 menubar) and the status bar.  When set to @qcode{\"auto\"}, the display is based on the value of the @code{menubar} property.";
+        s.category = "Mouse Interaction";
 
       case "units"
         s.doc = "The unit used to compute the @code{position} and \
 @code{outerposition} properties.";
+        s.category = "Position";
 
       case "windowbuttondownfcn"
         s.doc = "@xref{XREFfigurewindowbuttonupfcn, , \
 @w{windowbuttonupfcn property}}.";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "windowbuttonmotionfcn"
         s.doc = "@xref{XREFfigurewindowbuttonupfcn, , \
 @w{windowbuttonupfcn property}}.";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "windowbuttonupfcn"
         s.doc = "With @code{windowbuttondownfcn} and \
@@ -605,16 +698,19 @@
 @code{currentpoint} property holds the current coordinates of the cursor.\
 \n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "windowkeypressfcn"
         s.doc = "Function that is executed when a key is pressed and \
 the figure has focus.\n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Keyboard Interaction";
 
       case "windowkeyreleasefcn"
         s.doc = "Function that is executed when a key is released and \
 the figure has focus.\n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Keyboard Interaction";
 
       case "windowscrollwheelfcn"
         s.doc = "Function that is executed when a user manipulates \
@@ -633,6 +729,7 @@
 @end table\
 \n\n__fcnmsg__";
         s.valid = valid_fcn;
+        s.category = "Mouse Interaction";
 
       case "windowstyle"
         s.doc = "The window style of a figure.  One of the following values:\n\
@@ -646,7 +743,7 @@
 @end table\n\
 \n\
 Changing modes of a visible figure may cause the figure to close and reopen.";
-
+        s.category = "Display";
     endswitch
 
   ## Axes properties
@@ -655,60 +752,85 @@
       ## Overridden shared properties
       case "clipping"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "alim"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Display";
 
       case "alimmode"
+        s.category = "Display";
+
       case "ambientlightcolor"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "box"
         s.doc = "Control whether the __objname__ has a surrounding box.";
+        s.category = "Axes Box Appearance";
 
       case "boxstyle"
         s.doc = "For 3-D axes, control whether the @qcode{\"full\"} \
 box is drawn or only the 3 @qcode{\"back\"} axes";
+        s.category = "Axes Box Appearance";
 
       case "cameraposition"
         s.valid = valid_3elvec;
+        s.category = "Camera Info.";
 
       case "camerapositionmode"
+        s.category = "Camera Info.";
+
       case "cameratarget"
         s.valid = valid_3elvec;
+        s.category = "Camera Info.";
 
       case "cameratargetmode"
+        s.category = "Camera Info.";
+
       case "cameraupvector"
         s.valid = valid_3elvec;
+        s.category = "Camera Info.";
 
       case "cameraupvectormode"
+        s.category = "Camera Info.";
+
       case "cameraviewangle"
         s.valid = "scalar";
+        s.category = "Camera Info.";
 
       case "cameraviewanglemode"
+        s.category = "Camera Info.";
+
       case "clim"
         s.doc = "Define the limits for the color axis of image children.  \
 __modemsg__.  @xref{XREFpcolor, , @w{pcolor function}}.";
         s.valid = valid_2elvec;
+        s.category = "Camera Info.";
 
       case "climmode"
+        s.category = "Camera Info.";
 
       case "clippingstyle"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "color"
         s.doc = "Color of the __objname__ background.  \
 @xref{Colors, , colorspec}.";
         s.valid = valid_color;
+        s.category = "Axes Box Appearance";
 
       case "colororder"
         s.doc = "RGB values used by plot function for automatic line \
 coloring.";
         s.valid = "N-by-3 RGB matrix";
+        s.category = "Automatic Line Properties";
 
       case "colororderindex"
         s.doc = doc_unused;
+        s.category = "Automatic Line Properties";
 
       case "currentpoint"
         s.doc = "Matrix @code{[xf, yf, zf; xb, yb, zb]} which holds the \
@@ -720,6 +842,7 @@
 second row the furthest point.  The two points forms a line which is \
 perpendicular to the screen.";
         s.valid = "2-by-3 matrix";
+        s.category = "Mouse Interaction";
 
       case "dataaspectratio"
         s.doc = "Specify the relative height and width of the data \
@@ -728,80 +851,107 @@
 to be the same as the length of 2 units on the y-axis.  \
 @xref{XREFdaspect, , daspect function}.  __modemsg__.";
         s.valid = valid_3elvec;
+        s.category = "Axes Box Appearance";
 
       case "dataaspectratiomode"
+        s.category = "Axes Box Appearance";
+
       case "fontangle"
         s.doc = doc_fontangle;
+        s.category = "Annotation and Font";
 
       case "fontname"
         s.doc = doc_fontname;
         s.valid = valid_string;
+        s.category = "Annotation and Font";
 
       case "fontsize"
         s.doc = doc_fontsize;
         s.valid = "scalar";
+        s.category = "Annotation and Font";
 
       case "fontsmoothing"
         s.doc = "Control whether any text associated with __objname__ is anti-aliased.";
+        s.category = "Annotation and Font";
 
       case "fontunits"
         s.doc = doc_fontunits;
+        s.category = "Annotation and Font";
 
       case "fontweight"
         s.doc = doc_fontweight;
+        s.category = "Annotation and Font";
 
       case "gridalpha"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Axes Grid Appearance";
 
       case "gridalphamode"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "gridcolor"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "gridcolormode"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "gridlinestyle"
+        s.category = "Axes Grid Appearance";
 
       case "innerposition"
         s.doc = "The @qcode{\"innerposition\"} property is the same as the \
 @ref{XREFaxesposition, , @w{@qcode{\"position\"} property}}.";
         s.valid = valid_4elvec;
+        s.category = "Axes Grid Appearance";
 
       case "labelfontsizemultiplier"
         s.doc = "Ratio between the x/y/zlabel fontsize and the tick \
 label fontsize";
+        s.category = "Annotation and Font";
 
       case "layer"
         s.doc = "Control whether the axes is drawn below child graphics \
 objects (ticks, labels, etc.@: covered by plotted objects) or above.";
+        s.category = "Axes Box Appearance";
 
       case "linestyleorder"
         s.doc = doc_unused;
+        s.category = "Automatic Line Properties";
 
       case "linestyleorderindex"
         s.doc = doc_unused;
+        s.category = "Automatic Line Properties";
 
       case "linewidth"
         s.doc = "Width of the main axes lines";
+        s.category = "Axes Box Appearance";
 
       case "minorgridalpha"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Axes Grid Appearance";
 
       case "minorgridalphamode"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "minorgridcolor"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "minorgridcolormode"
         s.doc = doc_unused;
+        s.category = "Axes Grid Appearance";
 
       case "minorgridlinestyle"
+        s.category = "Axes Grid Appearance";
+
       case "mousewheelzoom"
         s.doc = "Fraction of axes limits to zoom for each wheel movement.";
         s.valid = "scalar in the range (0, 1)";
+        s.category = "Mouse Interaction";
 
       case "nextplot"
         s.doc = "__prop__ is used by high level plotting functions to \
@@ -809,6 +959,7 @@
 @xref{XREFnewplot, , @w{newplot function}}.  The state of __prop__ \
 is typically controlled using the @code{hold} function.  \
 @xref{XREFhold, , @w{hold function}}.";
+        ##Uncategorized
 
       case "outerposition"
         s.doc = "Specify the position of the plot including titles, \
@@ -820,11 +971,16 @@
 height to be 0.4 and 0.5 respectively.  \
 @xref{XREFaxesposition, , @w{position property}}.";
         s.valid = valid_4elvec;
+        s.category = "Position";
+
       case "plotboxaspectratio"
         s.doc = "@xref{XREFpbaspect, , pbaspect function}.  \
 __modemsg__.";
+        s.category = "Position";
 
       case "plotboxaspectratiomode"
+        s.category = "Position";
+
       case "position"
         if (strcmp (objname, "legend"))
           s.doc = "Specify the position of the legend excluding its title. \
@@ -843,6 +999,7 @@
 @xref{XREFaxesouterposition, , @w{outerposition property}}.";
         endif
         s.valid = valid_4elvec;
+        s.category = "Position";
 
       case "positionconstraint"
         s.doc = "Specify which of @qcode{\"innerposition\"} or \
@@ -850,45 +1007,56 @@
 annotations extent changes.  \
 @xref{XREFaxesinnerposition, , @w{@qcode{\"innerposition\"} property}}, \
 and @ref{XREFaxesouterposition, , @w{@qcode{\"outerposition\"} property}}.";
+        s.category = "Position";
 
       case "projection"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "sortmethod"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "tickdir"
         s.doc = "Control whether axes tick marks project \"in\" to the plot \
 box or \"out\".  __modemsg__.";
+        s.category = "Axes Box Appearance";
 
       case "tickdirmode"
+        s.category = "Axes Box Appearance";
 
       case "ticklabelinterpreter"
         s.doc = "Control the way x/y/zticklabel properties are interpreted.\n\
 @xref{XREFinterpreterusage, , @w{Use of the interpreter property}}.";
+        s.category = "Annotation and Font";
 
       case "ticklength"
         s.doc = "Two-element vector @code{[2Dlen 3Dlen]} specifying the \
 length of the tickmarks relative to the longest visible axis.";
         s.valid = valid_2elvec;
+        s.category = "Axes Box Appearance";
 
       case "tightinset"
         s.doc = "Size of the @code{[left bottom right top]} margins \
 around the axes that enclose labels and title annotations.";
         s.valid = valid_4elvec;
         s.printdefault = false;
+        s.category = "Position";
 
       case "title"
         s.doc = "Graphics handle of the title text object.";
         s.valid = valid_handle;
+        s.category = "Annotation and Font";
 
       case "titlefontsizemultiplier"
         s.doc = "Ratio between the title fontsize and the tick \
 label fontsize";
         s.valid = "positive scalar";
+        s.category = "Annotation and Font";
 
       case "titlefontweight"
         s.doc = "Control variant of base font used for the axes title.";
+        s.category = "Annotation and Font";
 
       case "units"
         if (strcmp (objname, "legend"))
@@ -898,141 +1066,206 @@
           s.doc = "Units used to interpret the @qcode{\"position\"}, \
 @qcode{\"outerposition\"}, and @qcode{\"tightinset\"} properties.";
         endif
+        s.category = "Position";
 
       case "view"
         s.doc = "Two-element vector @code{[azimuth elevation]} specifying \
 the viewpoint for three-dimensional plots";
         s.valid = valid_2elvec;
+        s.category = "Axes Box Appearance";
 
       case "xaxislocation"
         s.doc = "Control the x axis location.";
+        s.category = "Axes Box Appearance";
 
       case "xcolor"
         s.doc = "Color of the x-axis.  @xref{Colors, , colorspec}.  \
 __modemsg__.";
         s.valid = packopt ({markdef(valid_color), "@qcode{\"none\"}"});
+        s.category = "Axes Box Appearance";
 
       case "xcolormode"
+        s.category = "Axes Box Appearance";
 
       case "xdir"
         s.doc = "Direction of the x axis: @qcode{\"normal\"} is left \
 to right.";
+        s.category = "Axes Box Appearance";
 
       case "xgrid"
         s.doc = "Control whether major x grid lines are displayed.";
+        s.category = "Axes Grid Appearance";
 
       case "xlabel"
         s.doc = "Graphics handle of the x label text object.";
         s.valid = valid_handle;
+        s.category = "Annotation and Font";
 
       case "xlim"
         s.doc = "Two-element vector @code{[xmin xmax]} specifying the limits \
 for the x-axis.  __modemsg__.   @xref{XREFxlim, , @w{xlim function}}.";
         s.valid = valid_2elvec;
+        s.category = "Limits";
 
       case "xlimmode"
+        s.category = "Limits";
+
       case "xminorgrid"
         s.doc = "Control whether minor x grid lines are displayed.";
+        s.category = "Axes Grid Appearance";
 
       case "xminortick"
+        s.category = "Axes Grid Appearance";
+
       case "xscale"
+        s.category = "Axes Grid Appearance";
+
       case "xtick"
         s.doc = "Position of x tick marks.  __modemsg__.";
         s.valid = "vector";
         s.printdefault = false;
+        s.category = "Axes Grid Appearance";
 
       case "xticklabel"
         s.doc = "Labels of x tick marks.  __modemsg__.";
         s.valid = valid_cellstring;
+        s.category = "Annotation and Font";
 
       case "xticklabelmode"
+        s.category = "Annotation and Font";
+
       case "xticklabelrotation"
         s.doc = doc_unused;
+        s.category = "Annotation and Font";
 
       case "xtickmode"
+        s.category = "Annotation and Font";
+
       case "yaxislocation"
         s.doc = "Control the y-axis location.";
+        s.category = "Axes Box Appearance";
 
       case "ycolor"
         s.doc = "Color of the y-axis.  @xref{Colors, , colorspec}.";
         s.valid = packopt ({markdef(valid_color), "@qcode{\"none\"}"});
+        s.category = "Axes Box Appearance";
 
       case "ycolormode"
+        s.category = "Axes Box Appearance";
 
       case "ydir"
         s.doc = "Direction of the y-axis: @qcode{\"normal\"} is bottom \
 to top.";
+        s.category = "Axes Box Appearance";
 
       case "ygrid"
         s.doc = "Control whether major y grid lines are displayed.";
+        s.category = "Axes Box Appearance";
 
       case "ylabel"
         s.doc = "Graphics handle of the y label text object.";
         s.valid = valid_handle;
+        s.category = "Annotation and Font";
 
       case "ylim"
         s.doc = "Two-element vector @code{[ymin ymax]} specifying the limits \
 for the y-axis.  __modemsg__.  @xref{XREFylim, , @w{ylim function}}.";
         s.valid = valid_2elvec;
+        s.category = "Limits";
 
       case "ylimmode"
+        s.category = "Limits";
+
       case "yminorgrid"
         s.doc = "Control whether minor y grid lines are displayed.";
+        s.category = "Axes Grid Appearance";
 
       case "yminortick"
+        s.category = "Annotation and Font";
+
       case "yscale"
+        s.category = "Axes Grid Appearance";
+
       case "ytick"
         s.doc = "Position of y tick marks.  __modemsg__.";
         s.valid = "vector";
         s.printdefault = false;
+        s.category = "Axes Grid Appearance";
 
       case "yticklabel"
         s.doc = "Labels of y tick marks.  __modemsg__.";
         s.valid = valid_cellstring;
+        s.category = "Annotation and Font";
 
       case "yticklabelmode"
+        s.category = "Annotation and Font";
+
       case "yticklabelrotation"
         s.doc = doc_unused;
+        s.category = "Annotation and Font";
 
       case "ytickmode"
+        s.category = "Annotation and Font";
+
       case "zcolor"
         s.doc = "Color of the z-axis.  @xref{Colors, , colorspec}.";
         s.valid = packopt ({markdef(valid_color), "@qcode{\"none\"}"});
+        s.category = "Axes Box Appearance";
 
       case "zcolormode"
+        s.category = "Axes Box Appearance";
+
       case "zdir"
+        s.category = "Axes Box Appearance";
+
       case "zgrid"
         s.doc = "Control whether major z grid lines are displayed.";
+        s.category = "Axes Grid Appearance";
 
       case "zlabel"
         s.doc = "Graphics handle of the z label text object.";
         s.valid = valid_handle;
+        s.category = "Annotation and Font";
 
       case "zlim"
         s.doc = "Two-element vector @code{[zmin zmaz]} specifying the limits \
 for the z-axis.  __modemsg__.  @xref{XREFzlim, , @w{zlim function}}.";
         s.valid = valid_2elvec;
+        s.category = "Limits";
 
       case "zlimmode"
+        s.category = "Limits";
+
       case "zminorgrid"
         s.doc = "Control whether minor z grid lines are displayed.";
+        s.category = "Axes Grid Appearance";
 
       case "zminortick"
+        s.category = "Annotation and Font";
+
       case "zscale"
+        s.category = "Axes Grid Appearance";
+
       case "ztick"
         s.doc = "Position of z tick marks.  __modemsg__.";
         s.valid = "vector";
         s.printdefault = false;
+        s.category = "Axes Grid Appearance";
 
       case "zticklabel"
         s.doc = "Labels of z tick marks.  __modemsg__.";
         s.valid = valid_cellstring;
+        s.category = "Annotation and Font";
 
       case "zticklabelmode"
+        s.category = "Annotation and Font";
+
       case "zticklabelrotation"
         s.doc = doc_unused;
+        s.category = "Annotation and Font";
 
       case "ztickmode"
+        s.category = "Annotation and Font";
 
       ## Legend specific properties
       case "autoupdate"
@@ -1054,18 +1287,22 @@
 plot ((1:10) * 3);\n\
 @end group\n\
 @end example";
+        s.category = "Legend Item Appearance";
 
       case "edgecolor"
         s.doc = "Control the color of the legend outline.";
         s.valid = valid_color;
+        s.category = "Legend Outline Appearance";
 
       case "interpreter"
         s.doc = "Control if and eventually how labels strings are interpreted \
 before rendering.\n\
 @xref{XREFinterpreterusage, , @w{Use of the interpreter property}}.";
+        s.category = "Text Appearance";
 
       case "location"
         s.doc = "Control the location of the legend.";
+        s.category = "Position";
 
       case "numcolumns"
         s.doc = "Control the number of columns used in the layout of the legend items. \
@@ -1079,10 +1316,12 @@
 @end example\n\
 __modemsg__.";
         s.valid = "scalar interger";
+        s.category = "Legend Item Appearance";
 
       case "orientation"
         s.doc = "Control whether the legend items are arranged vertically \
 (column-wise) or horizontally (row-wise).";
+        s.category = "Legend Item Appearance";
 
       case "string"
         s.doc = "List of labels for the legend items.  For example:\n\
@@ -1100,14 +1339,17 @@
 @end example";
         s.valid = valid_cellstring;
         s.printdefault = false;
+        s.category = "Text Appearance";
 
       case "textcolor"
         s.doc = "Control the color of the text strings for legend items.";
         s.valid = valid_color;
+        s.category = "Text Appearance";
 
       case "textposition"
         s.doc = "Control whether text strings are displayed on the left or \
 right of their corresponding icon.";
+        s.category = "Text Appearance";
 
     endswitch
 
@@ -1117,74 +1359,91 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "color"
         s.doc = "Color of the line object.  @xref{Colors, , colorspec}.";
         s.valid = valid_color;
+        s.category = "Line Appearance";
 
       case "displayname"
         s.doc = "Text for the legend entry corresponding to this line.";
         s.valid = valid_cellstring;
+        s.category = "Text Appearance";
 
       case "interpreter"
+        s.category = "Unused";
 
       case "linestyle"
         s.doc = "@xref{Line Styles}.";
+        s.category = "Line Appearance";
 
       case "linewidth"
         s.doc = "Width of the line object measured in points.";
+        s.category = "Line Appearance";
 
       case "linejoin"
         s.doc = "Control the shape of the junction of line segments. \
 This property currently only affects the printed output.";
+        s.category = "Line Appearance";
 
       case "marker"
         s.doc = "Shape of the marker for each data point.  \
 @xref{Marker Styles}.";
+        s.category = "Marker Appearance";
 
       case "markeredgecolor"
         s.doc = "Color of the edge of the markers.  When set to \
 @qcode{\"auto\"}, the marker edges have the same color as the line.  If set \
 to @qcode{\"none\"}, no marker edges are displayed.  This property can also \
 be set to any color.  @xref{Colors, , colorspec}.";
+        s.category = "Marker Appearance";
 
       case "markerfacecolor"
         s.doc = "Color of the face of the markers.  When set to \
 @qcode{\"auto\"}, the marker faces have the same color as the line.  If set \
 to @qcode{\"none\"}, the marker faces are not displayed.  This property \
 can also be set to any color.  @xref{Colors, , colorspec}.";
+        s.category = "Marker Appearance";
 
       case "markersize"
         s.doc = "Size of the markers measured in points.";
         s.valid = "scalar";
+        s.category = "Marker Appearance";
 
       case "xdata"
         s.doc = "Vector of x data to be plotted.";
         s.valid = "vector";
+        s.category = "Data";
 
       case "xdatasource"
         s.doc = "Name of a vector in the current base workspace to use as \
 x data.";
         s.valid = valid_string;
+        s.category = "Data";
 
       case "ydata"
         s.doc = "Vector of y data to be plotted.";
         s.valid = "vector";
+        s.category = "Data";
 
       case "ydatasource"
         s.doc = "Name of a vector in the current base workspace to use as \
 y data.";
         s.valid = valid_string;
+        s.category = "Data";
 
       case "zdata"
         s.doc = "Vector of z data to be plotted.";
         s.valid = "vector";
+        s.category = "Data";
 
       case "zdatasource"
         s.doc = "Name of a vector in the current base workspace to use as \
 z data.";
         s.valid = valid_string;
+        s.category = "Data";
 
     endswitch
 
@@ -1194,88 +1453,114 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "backgroundcolor"
         s.doc = "Color of the background area.  \
 @xref{Colors, , colorspec}.";
         s.valid = valid_color;
+        s.category = "Box Appearance";
 
       case "color"
         s.doc = "Color of the text.  @xref{Colors, ,colorspec}.";
         s.valid = valid_color;
+        s.category = "Text Appearance";
 
       case "displayname"
+        s.category = "Unused";
+
       case "edgecolor"
         s.doc = "Color of the outline of the background area.  \
 @xref{Colors, , colorspec}.";
         s.valid = valid_color;
+        s.category = "Box Appearance";
 
       case "editing"
         s.doc = doc_unused;
+        s.category = "Position";
 
       case "extent"
         s.doc = "Vector @code{[x0 y0 width height]} indicating the size \
 and location of the text string.";
         s.valid = valid_4elvec;
         s.printdefault = false;
+        s.category = "Position";
 
       case "fontangle"
         s.doc = doc_fontangle;
+        s.category = "Font";
 
       case "fontname"
         s.doc = doc_fontname;
         s.valid = valid_string;
+        s.category = "Font";
 
       case "fontsmoothing"
         s.doc = "Control whether anti-aliasing is used when rendering text.";
+        s.category = "Font";
 
       case "fontsize"
         s.doc = doc_fontsize;
         s.valid = "scalar";
+        s.category = "Font";
 
       case "fontunits"
         s.doc = doc_fontunits;
+        s.category = "Font";
 
       case "fontweight"
         s.doc = doc_fontweight;
+        s.category = "Font";
 
       case "horizontalalignment"
+        s.category = "Position";
+
       case "interpreter"
         s.doc = "Control the way the @qcode{\"string\"} property is \
 interpreted.\n\
 @xref{XREFinterpreterusage, , @w{Use of the interpreter property}}.";
+        s.category = "Text Appearance";
 
       case "linestyle"
         s.doc = "Style of the outline.  @xref{Line Styles}.";
+        s.category = "Box Appearance";
 
       case "linewidth"
         s.doc = "Width of the outline.";
         s.valid = "scalar";
+        s.category = "Box Appearance";
 
       case "margin"
         s.doc = "Margins between the borders of the background area \
 and the texts.  The value is currently interpreted as pixels, regardless \
 of the @qcode{\"fontunits\"} property.";
         s.valid = "scalar";
+        s.category = "Box Appearance";
 
       case "position"
         s.doc = "Vector @code{[X0 Y0 Z0]} where X0, Y0, and Z0 indicate the \
 position of the text anchor as defined by @code{verticalalignment} and \
 @code{horizontalalignment}.";
         s.valid = valid_3elvec;
+        s.category = "Position";
 
       case "rotation"
         s.doc = "The angle of rotation for the displayed text, \
 measured in degrees.";
         s.valid = "scalar";
+        s.category = "Position";
 
       case "string"
         s.doc = "The text object string content.";
         s.valid = valid_string;
+        s.category = "Text Appearance";
 
       case "units"
+        s.category = "Position";
+
       case "verticalalignment"
+        s.category = "Position";
     endswitch
 
   ## Image properties
@@ -1284,22 +1569,29 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "alphadata"
         s.doc = sprintf (doc_notimpl, "Transparency");
         s.valid = valid_scalmat;
+        s.category = "Data";
 
       case "alphadatamapping"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Data";
 
       case "cdata"
         s.valid = "matrix";
+        s.category = "Data";
 
       case "cdatamapping"
+        s.category = "Data";
+        
       case "displayname"
         s.doc = "Text for the legend entry corresponding to this image.";
         s.valid = valid_cellstring;
+        s.category = "Text Appearance";
 
       case "xdata"
         s.doc = "Two-element vector @code{[xfirst xlast]} specifying the x \
@@ -1308,6 +1600,7 @@
 Setting @code{xdata} to the empty matrix ([]) will restore the default value \
 of @code{[1 columns(image)]}.";
         s.valid = valid_2elvec;
+        s.category = "Data";
 
       case "ydata"
         s.doc = "Two-element vector @code{[yfirst ylast]} specifying the y \
@@ -1316,6 +1609,7 @@
 Setting @code{ydata} to the empty matrix ([]) will restore the default value \
 of @code{[1 rows(image)]}.";
         s.valid = valid_2elvec;
+        s.category = "Data";
 
     endswitch
 
@@ -1325,42 +1619,58 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "alphadata"
         s.doc = sprintf (doc_notimpl, "Transparency");
         s.valid = valid_scalmat;
+        s.category = "Data";
 
       case "alphadatamapping"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Data";
 
       case "ambientstrength"
         s.doc = "Strength of the ambient light. Value between 0.0 and 1.0";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "backfacelighting"
         s.doc = "@qcode{\"lit\"}: The normals are used as is for lighting. \
 @qcode{\"reverselit\"}: The normals are always oriented towards the point of view. \
-@qcode{\"unlit\"}: Faces with normals pointing away from the point of view are unlit.";
+@qcode{\"unlit\"}: Faces with normals pointing away from the point of \
+view are unlit.";
+        s.category = "Lighting";
 
       case "cdata"
         s.valid = "matrix";
+        s.category = "Data";
 
       case "cdatamapping"
+        s.category = "Data";
+
       case "cdatasource"
+        s.category = "Data";
+      
       case "diffusestrength"
         s.doc = "Strength of the diffuse reflex. Value between 0.0 (no \
 diffuse reflex) and 1.0 (full diffuse reflex).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "displayname"
         s.doc = "Text for the legend entry corresponding to this surface.";
+        s.category = "Text Appearance";
 
       case "edgealpha"
         s.doc = sprintf (doc_notimpl, "Transparency");
         s.valid = "scalar";
+        s.category = "Outline Appearance";
 
       case "edgecolor"
+        s.category = "Outline Appearance";
+
       case "edgelighting"
         s.doc = "When set to a value other than @qcode{\"none\"}, the edges \
 of the object are drawn with light and shadow effects.  Supported values are \
@@ -1368,6 +1678,7 @@
 @qcode{\"gouraud\"} (linear interpolation of the lighting effects between \
 the vertices). @qcode{\"phong\"} is deprecated and has the same effect as \
 @qcode{\"gouraud\"}.";
+        s.category = "Lighting";
 
       case "facealpha"
         s.doc = "Transparency level of the faces of the surface object.  Only \
@@ -1381,8 +1692,11 @@
                             "@qcode{\"flat\"}", ...
                             "@qcode{\"interp\"}", ...
                             "@qcode{\"texturemap\"}"});
+        s.category = "Data";
 
       case "facecolor"
+        s.category = "Data";
+        
       case "facelighting"
         s.doc = "When set to a value other than @qcode{\"none\"}, the faces \
 of the object are drawn with light and shadow effects.  Supported values are \
@@ -1390,80 +1704,106 @@
 @qcode{\"gouraud\"} (linear interpolation of the lighting effects between \
 the vertices). @qcode{\"phong\"} is deprecated and has the same effect as \
 @qcode{\"gouraud\"}.";
+        s.category = "Lighting";
 
       case "facenormals"
         s.doc = "Face normals are used for lighting the edges or faces if the \
 @code{edgelighting} or @code{facelighting} properties are set to \
 @qcode{\"flat\"}.  __modemsg__";
+        s.category = "Lighting";
 
       case "facenormalsmode"
         s.doc = "If this property is set to @qcode{\"auto\"}, \
 @code{facenormals} are automatically calculated if the @code{edgelighting} or \
 @code{facelighting} property are set to @qcode{\"flat\"} and at least one \
 @code{light} object is present and visible in the same axes.";
+        s.category = "Lighting";
 
       case "interpreter"
+        s.category = "Unused";
+        
       case "linestyle"
         s.doc = "@xref{Line Styles}.";
+        s.category = "Outline Appearance";
 
       case "linewidth"
         s.doc = "@xref{XREFlinelinewidth, , @w{line linewidth property}}.";
+        s.category = "Outline Appearance";
 
       case "marker"
         s.doc = "@xref{Marker Styles}.";
+        s.category = "Marker Appearance";
 
       case "markeredgecolor"
         s.doc = "@xref{XREFlinemarkeredgecolor, , \
 @w{line markeredgecolor property}}.";
+        s.category = "Marker Appearance";
 
       case "markerfacecolor"
         s.doc = "@xref{XREFlinemarkerfacecolor, , \
 @w{line markerfacecolor property}}.";
+        s.category = "Marker Appearance";
 
       case "markersize"
         s.doc = "@xref{XREFlinemarkersize, , \
 @w{line markersize property}}.";
         s.valid = "scalar";
+        s.category = "Marker Appearance";
 
       case "meshstyle"
+        s.category = "Outline Appearance";
+        
       case "specularcolorreflectance"
         s.doc = "Reflectance for specular color. Value between 0.0 (color \
 of underlying face) and 1.0 (color of light source).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "specularexponent"
         s.doc = "Exponent for the specular reflex. The lower the value, \
 the more the reflex is spread out.";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "specularstrength"
         s.doc = "Strength of the specular reflex. Value between 0.0 (no \
 specular reflex) and 1.0 (full specular reflex).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "vertexnormals"
         s.doc = "Vertex normals are used for lighting the edges or faces if \
 the @code{edgelighting} or @code{facelighting} properties are set to \
 @qcode{\"gouraud\"}.  __modemsg__";
+        s.category = "Lighting";
 
       case "vertexnormalsmode"
         s.doc = "If this property is set to @qcode{\"auto\"}, \
 @code{vertexnormals} are automatically calculated if the @code{edgelighting} \
 or @code{facelighting} property are set to @qcode{\"gouraud\"} and at least \
 one @code{light} object is present and visible in the same axes.";
+        s.category = "Lighting";
 
       case "xdata"
         s.valid = "matrix";
+        s.category = "Data";
 
       case "xdatasource"
+        s.category = "Data";
+        
       case "ydata"
         s.valid = "matrix";
+        s.category = "Data";
 
       case "ydatasource"
+        s.category = "Data";
+        
       case "zdata"
         s.valid = "matrix";
+        s.category = "Data";
 
       case "zdatasource"
+        s.category = "Data";
     endswitch
 
   ## Patch properties
@@ -1472,19 +1812,23 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "alphadatamapping"
         s.doc = sprintf (doc_notimpl, "Transparency");
+        s.category = "Data";
 
       case "ambientstrength"
         s.doc = "Strength of the ambient light. Value between 0.0 and 1.0";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "backfacelighting"
         s.doc =  "@qcode{\"lit\"}: The normals are used as is for lighting. \
 @qcode{\"reverselit\"}: The normals are always oriented towards the point of view. \
 @qcode{\"unlit\"}: Faces with normals pointing away from the point of view are unlit.";
+        s.category = "Lighting";
 
       case "cdata"
         s.doc = "Data defining the patch object color.\n\
@@ -1499,20 +1843,26 @@
 If @code{cdata} is an N-by-M or an N-by-M-by-3 (RGB) matrix, \
 it defines the color at each vertex.";
         s.valid = valid_scalmat;
+        s.category = "Data";
 
       case "diffusestrength"
         s.doc = "Strength of the diffuse reflex. Value between 0.0 (no \
 diffuse reflex) and 1.0 (full diffuse reflex).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "displayname"
         s.doc = "Text of the legend entry corresponding to this patch.";
+        s.category = "Text Appearance";
 
       case "edgealpha"
         s.doc = sprintf (doc_notimpl, "Transparency");
         s.valid = valid_scalmat;
+        s.category = "Outline Appearance";
 
       case "edgecolor"
+        s.category = "Outline Appearance";
+        
       case "edgelighting"
         s.doc = "When set to a value other than @qcode{\"none\"}, the edges \
 of the object are drawn with light and shadow effects.  Supported values are \
@@ -1520,6 +1870,7 @@
 @qcode{\"gouraud\"} (linear interpolation of the lighting effects between \
 the vertices). @qcode{\"phong\"} is deprecated and has the same effect as \
 @qcode{\"gouraud\"}.";
+        s.category = "Lighting";
 
       case "facealpha"
         s.doc = "Transparency level of the faces of the patch object.  Only \
@@ -1532,6 +1883,7 @@
         s.valid = packopt ({"scalar", ...
                             "@qcode{\"flat\"}", ...
                             "@qcode{\"interp\"}"});
+        s.category = "Data";
 
       case "facecolor"
         ## Don't provide a default value, and mark colorspec with
@@ -1540,6 +1892,7 @@
                             "@qcode{\"none\"}", ...
                             "@qcode{\"flat\"}", ...
                             "@qcode{\"interp\"}"});
+        s.category = "Data";
 
       case "facelighting"
         s.doc = "When set to a value other than @qcode{\"none\"}, the faces \
@@ -1548,84 +1901,108 @@
 @qcode{\"gouraud\"} (linear interpolation of the lighting effects between \
 the vertices). @qcode{\"phong\"} is deprecated and has the same effect as \
 @qcode{\"gouraud\"}.";
+        s.category = "Lighting";
 
       case "facenormals"
         s.doc = "Face normals are used for lighting the edges or faces if the \
 @code{edgelighting} or @code{facelighting} properties are set to \
 @qcode{\"flat\"}.  __modemsg__";
+        s.category = "Lighting";
 
       case "facenormalsmode"
         s.doc = "If this property is set to @qcode{\"auto\"}, \
 @code{facenormals} are automatically calculated if the @code{edgelighting} or \
 @code{facelighting} property are set to @qcode{\"flat\"} and at least one \
 @code{light} object is present and visible in the same axes.";
+        s.category = "Lighting";
 
       case "faces"
         s.valid = valid_vecmat;
+        s.category = "Data";
 
       case "facevertexalphadata"
         s.doc = sprintf (doc_notimpl, "Transparency");
         s.valid = valid_scalmat;
+        s.category = "Data";
 
       case "facevertexcdata"
+        s.category = "Data";
+        
       case "interpreter"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       case "linestyle"
+        s.category = "Outline Appearance";
+        
       case "linewidth"
+        s.category = "Outline Appearance";
+        
       case "marker"
         s.doc = "@xref{XREFlinemarker, , @w{line marker property}}.";
+        s.category = "Marker Appearance";
 
       case "markeredgecolor"
         s.doc = "@xref{XREFlinemarkeredgecolor, , \
 @w{line markeredgecolor property}}.";
+        s.category = "Marker Appearance";
 
       case "markerfacecolor"
         s.doc = "@xref{XREFlinemarkerfacecolor, , \
 @w{line markerfacecolor property}}.";
+        s.category = "Marker Appearance";
 
       case "markersize"
         s.doc = "@xref{XREFlinemarkersize, , @w{line markersize property}}.";
         s.valid = "scalar";
+        s.category = "Marker Appearance";
 
       case "specularcolorreflectance"
         s.doc = "Reflectance for specular color.  Value between 0.0 (color \
 of underlying face) and 1.0 (color of light source).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "specularexponent"
         s.doc = "Exponent for the specular reflex.  The lower the value, \
 the more the reflex is spread out.";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "specularstrength"
         s.doc = "Strength of the specular reflex.  Value between 0.0 (no \
 specular reflex) and 1.0 (full specular reflex).";
         s.valid = "scalar";
+        s.category = "Lighting";
 
       case "vertexnormals"
         s.doc = "Vertex normals are used for lighting the edges or faces if \
 the @code{edgelighting} or @code{facelighting} properties are set to \
 @qcode{\"gouraud\"}.  __modemsg__";
+        s.category = "Lighting";
 
       case "vertexnormalsmode"
         s.doc = "If this property is set to @qcode{\"auto\"}, \
 @code{vertexnormals} are automatically calculated if the @code{edgelighting} \
 or @code{facelighting} property are set to @qcode{\"gouraud\"} and at least \
 one @code{light} object is present and visible in the same axes.";
+        s.category = "Lighting";
 
       case "vertices"
         s.valid = valid_vecmat;
+        s.category = "Data";
 
       case "xdata"
         s.valid = valid_vecmat;
+        s.category = "Data";
 
       case "ydata"
         s.valid = valid_vecmat;
+        s.category = "Data";
 
       case "zdata"
         s.valid = valid_vecmat;
-
+        s.category = "Data";
     endswitch
 
   ## Scatter properties
@@ -1634,15 +2011,18 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "cdatamode"
         s.doc = "If @code{cdatamode} is @qcode{\"auto\"}, @code{cdata} is set \
 to the color from the @code{colororder} of the ancestor axes corresponding to \
 the @code{seriesindex}.";
+        s.category = "Data";
 
       case "cdatasource"
         s.doc = sprintf (doc_notimpl, "Data from workspace variables");
+        s.category = "Data";
 
       case "cdata"
         s.doc = "Data defining the scatter object color.\n\
@@ -1653,16 +2033,19 @@
 If @code{cdata} is an N-by-1 vector of indices or an N-by-3 (RGB) matrix, \
 it defines the color of each one of the N scatter markers.";
         s.valid = valid_scalmat;
-
+        s.category = "Data";
 
       case "displayname"
         s.doc = "Text of the legend entry corresponding to this scatter object.";
+        s.category = "Text Appearance";
 
       case "linewidth"
         s.doc = "Line width of the edge of the markers.";
+        s.category = "Outline Appearance";
 
       case "marker"
         s.doc = "@xref{XREFlinemarker, , @w{line marker property}}.";
+        s.category = "Marker Appearance";
 
       case "markeredgealpha"
         s.doc = "Transparency level of the faces of the markers where a \
@@ -1671,6 +2054,7 @@
 front which might lead to unexpected results when rendering layered \
 transparent markers or in combination with other transparent objects.";
         s.valid = "scalar";
+        s.category = "Marker Appearance";
 
       case "markeredgecolor"
         s.doc = "Color of the edge of the markers.  @qcode{\"none\"} means \
@@ -1680,6 +2064,7 @@
         s.valid = packopt ({markdef("@qcode{\"none\"}"), ...
                             "@qcode{\"flat\"}", ...
                             valid_color});
+        s.category = "Marker Appearance";
 
       case "markerfacealpha"
         s.doc = "Transparency level of the faces of the markers where a \
@@ -1688,6 +2073,7 @@
 front which might lead to unexpected results when rendering layered \
 transparent markers or in combination with other transparent objects.";
         s.valid = "scalar";
+        s.category = "Marker Appearance";
 
       case "markerfacecolor"
         s.doc = "Color of the face of the markers.  @qcode{\"none\"} means \
@@ -1699,43 +2085,53 @@
                             "@qcode{\"flat\"}", ...
                             "@qcode{\"auto\"}", ...
                             valid_color});
+        s.category = "Marker Appearance";
 
       case "seriesindex"
         s.doc = "Each scatter object in the same axes is asigned an \
 incrementing integer.  This corresponds to the index into the \
 @code{colororder} of the ancestor axes that is used if @code{cdatamode} is \
 set to @qcode{\"auto\"}.";
+        s.category = "Data";
 
       case "sizedatasource"
         s.doc = sprintf (doc_notimpl, "Data from workspace variables");
+        s.category = "Data";
 
       case "sizedata"
         s.doc = "Size of the area of the marker. A scalar value applies to \
 all markers.  If @code{cdata} is an N-by-1 vector, it defines the color of \
 each one of the N scatter markers.";
         s.valid =  packopt ({"[]", "scalar", "vector"});
+        s.category = "Data";
 
       case "xdatasource"
         s.doc = sprintf (doc_notimpl, "Data from workspace variables");
+        s.category = "Data";
 
       case "xdata"
         s.doc = "Vector with the x coordinates of the scatter object.";
         s.valid = "vector";
+        s.category = "Data";
 
       case "ydatasource"
         s.doc = sprintf (doc_notimpl, "Data from workspace variables");
+        s.category = "Data";
 
       case "ydata"
         s.doc = "Vector with the y coordinates of the scatter object.";
         s.valid = "vector";
+        s.category = "Data";
 
       case "zdatasource"
         s.doc = sprintf (doc_notimpl, "Data from workspace variables");
+        s.category = "Data";
 
       case "zdata"
         s.doc = "For 3D data, vector with the y coordinates of the scatter \
 object.";
         s.valid = packopt ({"[]", "vector"});
+        s.category = "Data";
 
     endswitch
 
@@ -1745,19 +2141,23 @@
       ## Overridden shared properties
       case "children"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "color"
         s.doc = "Color of the light source.  @xref{Colors, ,colorspec}.";
         s.valid = valid_color;
+        s.category = "Lighting";
 
       case "position"
         s.doc = "Position of the light source.";
+        s.category = "Lighting";
 
       case "style"
         s.doc = "This string defines whether the light emanates from a \
 light source at infinite distance (@qcode{\"infinite\"}) or from a local \
 point source (@qcode{\"local\"}).";
+        s.category = "Lighting";
 
     endswitch
 
@@ -1767,6 +2167,7 @@
       ## Overridden shared properties
       case "buttondownfcn"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "accelerator"
@@ -1786,6 +2187,7 @@
       ## Overridden shared properties
       case "buttondownfcn"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "callback"
@@ -1996,6 +2398,7 @@
       ## Overridden shared properties
       case "buttondownfcn"
         s.doc = doc_unused;
+        s.category = "Unused";
 
     endswitch
 
@@ -2005,6 +2408,7 @@
       ## Overridden shared properties
       case "buttondownfcn"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "cdata"
@@ -2021,6 +2425,7 @@
       ## Overridden shared properties
       case "buttondownfcn"
         s.doc = doc_unused;
+        s.category = "Unused";
 
       ## Specific properties
       case "cdata"
@@ -2188,10 +2593,10 @@
 endfunction
 
 function str = printdoc (objname, obj, is_prop_subset)
-  ## Sort fields so that they appear in alphabetic order in the manual
-  fields = sort (fieldnames (obj));
-  nf = numel (fields);
-
+##  ## Sort fields so that they appear in alphabetic order in the manual
+##  fields = sort (fieldnames (obj));
+##  nf = numel (fields);
+##
   ## File header and beginning of properties table
   str = warn_autogen ();
   if (strcmp (objname, "root"))
@@ -2202,45 +2607,62 @@
     str = sprintf ("%s\n\nProperties of @code{%s} objects (@pxref{XREF%s,,%s}):",
                    str, objname, objname, objname);
   endif
-  str = sprintf ("%s\n\n@table @asis", str);
-
-  for ii = 1:nf
-    field = fields{ii};
-    str = sprintf ("%s\n\n", str);
-
-    if (! is_prop_subset)
-      ## @anchor: cross reference using XREFobjnamefield label
-      ## Concept index: call info from octave with 'doc ("objname field")'
-      str = sprintf ("%s@anchor{XREF%s%s}\n@prindex %s %s\n",
-                     str, objname, field, objname, field);
-    endif
-
-    ## Item
-    str = sprintf ("%s@item @code{%s}", str, field);
-
-    ## Mark item read-only if needed
-    if (obj.(field).isreadonly)
-      str = sprintf ("%s (read-only):", str);
-    else
-      str = sprintf ("%s:", str);
-    endif
-
-    ## Print valid and default values
-    tmp = print_options (obj.(field).valid,
-                         obj.(field).default);
-    if (! isempty (tmp))
-      str = sprintf ("%s %s\n", str, tmp);
-    else
-      str = sprintf ("%s\n", str);
-    endif
-
-    ## Print documentation
-    str = sprintf ("%s%s\n", str, obj.(field).doc);
+
+  ## Sort fields by category, put the special categories "Miscellaneous" and
+  ## "Unused" last.
+  allfields = fieldnames (obj);
+  allcategories = cellfun (@(s) obj.(s).category, allfields, "uni", false);
+  categories = unique (allcategories);
+  idx = strcmp (categories, "Miscellaneous");
+  categories = [categories(!idx); categories(idx)];
+  idx = strcmp (categories, "Unused");
+  categories = [categories(!idx); categories(idx)];
+
+  idx = [];
+  for ii = 1:numel (categories)
+    fields = sort (allfields(strcmp (allcategories, categories{ii})));
+    nf = numel (fields);
+    str = sprintf ("%s\n\n@chapheading %s", str, categories{ii});   
+    str = sprintf ("%s\n\n@table @asis", str);
+
+    for jj = 1:nf
+      field = fields{jj};
+      str = sprintf ("%s\n\n", str);
+
+      if (! is_prop_subset)
+        ## @anchor: cross reference using XREFobjnamefield label
+        ## Concept index: call info from octave with 'doc ("objname field")'
+        str = sprintf ("%s@anchor{XREF%s%s}\n@prindex %s %s\n",
+                       str, objname, field, objname, field);
+      endif
+
+      ## Item
+      str = sprintf ("%s@item @code{%s}", str, field);
+
+     ## Mark item read-only if needed
+      if (obj.(field).isreadonly)
+        str = sprintf ("%s (read-only):", str);
+      else
+        str = sprintf ("%s:", str);
+      endif
+
+      ## Print valid and default values
+      tmp = print_options (obj.(field).valid,
+                           obj.(field).default);
+      if (! isempty (tmp))
+        str = sprintf ("%s %s\n", str, tmp);
+      else
+        str = sprintf ("%s\n", str);
+      endif
+
+      ## Print documentation
+      str = sprintf ("%s%s\n", str, obj.(field).doc);
+    endfor
+
+    ## End of properties table
+    str = sprintf ("%s\n@end table", str);
   endfor
 
-  ## End of properties table
-  str = sprintf ("%s\n@end table", str);
-
 endfunction
 
 function str = warn_autogen ()
